#ifndef CANDIDATE_H
#define CANDIDATE_H

#include "OS.h"
#include "AppDefs.h"
#include "Message.h"

#define KILL_INTERVAL 1E7
// microsecs in between two kills
// low value -> kill often, high value -> seldom murder

#define KILL_TRESHOLD 1E4
// if user_time akku is higher, window kill will be postponed
// higher values -> later killing, too low value -> no killing ever
// better use LAZYNESS

#define LAZYNESS 0.95
// gives the value for user_time akku to unload 
// higher values -> later kill (respective to usage)

class Candidate {
	public:
		Candidate(const thread_info &t_info);
		bool operator ==(const thread_info *t_info);
		double Check();
		double GetAccu();
		void Kill();
	protected:
		thread_info threadInfo;
		bigtime_t last_user_time;
		double diff_accu;
};

#endif