#include "Candidate.h"

Candidate::Candidate(const thread_info &t_info) {
	threadInfo = t_info;
	last_user_time = threadInfo.user_time;
	diff_accu = KILL_TRESHOLD*100;
}

bool Candidate::operator==(const thread_info *t_info) {
	return(threadInfo.thread==t_info->thread);
}

double Candidate::Check() {
	get_thread_info(threadInfo.thread, &threadInfo);
	bigtime_t diff = threadInfo.user_time - last_user_time;
	diff_accu = (diff_accu*LAZYNESS) + (((double)diff)*(1.0-LAZYNESS));
	last_user_time = threadInfo.user_time;
	//printf("%s diff time: %i, accu: %f\n", threadInfo.name, (int32)diff, diff_accu);
	return(diff_accu);
}

double Candidate::GetAccu() {
	return(diff_accu);
}

void Candidate::Kill() {
	//printf("killing %s\n", threadInfo.name);
	BMessage *msg = new BMessage(B_GET_PROPERTY);
	BMessage reply;
	msg->AddSpecifier("Messenger");
	msg->AddSpecifier("Window", threadInfo.name+2);
	BMessenger *tmpMessenger = new BMessenger("application/x-vnd.Be-TRAK");
	tmpMessenger->SendMessage(msg, &reply);
	reply.FindMessenger("result", tmpMessenger);
	tmpMessenger->SendMessage(B_QUIT_REQUESTED);
}

